# inherit.h File Reference

`#include <gwenhywfar/misc.h>`
`#include <gwenhywfar/gwenhywfarapi.h>`

Go to the source code of this file.

## Macros To Be Used In Inheriting Classes

#define | GWEN_INHERIT(bt, t) GWEN_TYPE_UINT32 t##__INHERIT_ID=0;
#define | GWEN_INHERIT_GETDATA(bt, t, element) ((t*)GWEN_Inherit_FindData(bt##__INHERIT_GETLIST(element),t##__INHERIT_ID,0))
#define | GWEN_INHERIT_ISOFTYPE(bt, t, element)
#define | GWEN_INHERIT_SETDATA(bt, t, element, data, fn)
#define | GWEN_INHERIT_UNLINK(bt, t, element)

## Macros To Be Used In Inherited Classes - Header Files

#define | GWEN_INHERIT_ELEMENT(t) GWEN_INHERITDATA_LIST *INHERIT__list;
#define | GWEN_INHERIT_FUNCTION_DEFS(t) GWEN_INHERIT_FUNCTION_LIB_DEFS(t, GWEN_DUMMY_EMPTY_ARG)
#define | GWEN_INHERIT_FUNCTION_LIB_DEFS(t, decl)

## Macros To Be Used In Inherited Classes - C Files

#define | GWEN_INHERIT_FINI(t, element)
#define | GWEN_INHERIT_FUNCTIONS(t)
#define | GWEN_INHERIT_INIT(t, element)

## Typedefs

typedef void(* | GWEN_INHERIT_FREEDATAFN )(void *baseData, void *data)
typedef GWEN_INHERITDATA | GWEN_INHERITDATA

## Functions

GWENHYWFAR_API void * | GWEN_Inherit_FindData (GWEN_INHERITDATA_LIST *l, GWEN_TYPE_UINT32 id, int wantCreate)
GWENHYWFAR_API GWEN_INHERITDATA * | GWEN_Inherit_FindEntry (GWEN_INHERITDATA_LIST *l, GWEN_TYPE_UINT32 id, int wantCreate)
GWENHYWFAR_API GWEN_TYPE_UINT32 | GWEN_Inherit_MakeId (const char *typeName)
GWENHYWFAR_API void | GWEN_InheritData_clear (GWEN_INHERITDATA *d)
GWENHYWFAR_API void | GWEN_InheritData_free (GWEN_INHERITDATA *d)
GWENHYWFAR_API void * | GWEN_InheritData_GetData (const GWEN_INHERITDATA *d)
GWENHYWFAR_API GWEN_INHERIT_FREEDATAFN | GWEN_InheritData_GetFreeDataFn (const GWEN_INHERITDATA *d)
GWENHYWFAR_API GWEN_TYPE_UINT32 | GWEN_InheritData_GetId (const GWEN_INHERITDATA *d)
GWENHYWFAR_API const char * | GWEN_InheritData_GetTypeName (const GWEN_INHERITDATA *d)
GWENHYWFAR_API GWEN_INHERITDATA * | GWEN_InheritData_new (const char *t, GWEN_TYPE_UINT32 id, void *data, void *baseData, GWEN_INHERIT_FREEDATAFN fn)

## Typedef Documentation

typedef struct GWEN_INHERITDATA GWEN_INHERITDATA